#include <adc.h>
#include <delays.h>

#include "CAN.h"




// --------------------------------------------------------------------------
/* Fonction CAN_Init
 * Initialise les convertisseurs Analogiques/Numriques (et les ports lis)
*/
void CAN_Init(void)
{

	TRIS_JOY_Y=1;			// Port de joystick (Y) en entre
	TRIS_JOY_X=1;			// Port de joystick (X) en entre
	TRIS_BAT_18V=1;			// Port de mesure de la batterie 18.5V en entre
	TRIS_BAT_12V=1;			// Port de mesure de la batterie 12V en entre
	TRIS_TEL_30=1;			// Port du tlmtre 30cm en entre
	TRIS_TEL_150=1;			// Port du tlmtre 150cm en entre

	// Configure le convertisseur analogique / numrique
	OpenADC(	ADC_FOSC_2 &		// Quartz divis par 2
				ADC_RIGHT_JUST &	// Ajustement  droite
				ADC_6ANA_0REF,		// 6 convertisseurs anamogiques, 2 ports numriques
				ADC_INT_OFF);		// Pas d'interruptions
}




// --------------------------------------------------------------------------
/* Fonction CAN_Convert
 * Effectue une conversion sur le canal pass en paramtre
 * La valeur retourne est le rsultat brut de la converion
 * appartenant  l'intervalle [0;1023]
*/
int CAN_Convert(unsigned char Canal)
{
	SetChanADC(Canal);			// Slectionne le canal 
	Delay10TCYx(DELAY_SEL_ADC);	// Attends quelques cycles
	ConvertADC(); 				// Dmare la conversion
	while( BusyADC() ); 		// Attend la fin de la conversions
	return (ReadADC()); 	// Retourne le rsultat mis en form
}