// Fichier Distributeru.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *					strategie							*
 *                                                      *
 *                                                     	*
 * .Date de cration : 09/05/07                         *
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour les distributeur 		*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/


#include "Constante.h"
#include "Distributeur.h"
#include "Recal.h"

#include "mystdio.h"
#include <Delays.h>

volatile char		Nb_Balles_Distributeur_Blanc_Rouge=5;						// Nombre de balles dans le distributeur blanc du ct bleu
volatile char		Nb_Balles_Distributeur_Bleu=5;								// Nombre de balles dans le distributeur bleu
volatile char		Nb_Balles_Distributeur_Rouge=5;								// Nombre de balles dans le distributeur rouge
volatile char		Nb_Balles_Distributeur_Blanc_Bleu=5;						// Nombre de balles dans le distributeur blanc du ct rouge






// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur bleu
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments :
 * 	Le nombre de balles bleues dsir dans le barillet
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 *
 * Paramtre retourn :
 *  aucun
*/

void Distributeur_Bleu (char NbBalles, char NbEssaisSup)
{
	char NbBalleDebut=NbBalles_Barillet(BLEUE);						// On regarde le nombre de balles dans le barillet avant la manoeuvre
	char i=NbBalleDebut-NbEssaisSup;									// On initialise i avec le nombre de blanches dj prsentes dans le barillet - le nombre d'essais suplmentaires

	if (NbBalles-NbBalleDebut>Nb_Balles_Distributeur_Bleu)				// S'il y a moins de balles dans le distributeur que ce que l'on souhaite prendre
		NbBalles=NbBalleDebut+Nb_Balles_Distributeur_Bleu;			// On prend le maximum

	while(	NbBalles_Barillet(BLEUE)<NbBalles &&			 			// Si on a pas le nombre de balles dsir ...
			NbBalles_Barillet(TOUTES)<5	&&								// ... et que le barillet n'est pas plein
			i<NbBalles)													// ... et qu'on a pas encore puise notre quota de tentatives
	{
		Commande_Rouleaux(120, 90);										// On fait tourner les rouleaux pour attraper les balles

		GotoXY_Propulsion(2300, 0, 25);									// Avancer doucement vers le distributeur
		while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
				!Barillet_Avale() &&									// ... ou qu'on vient de pcho une balle
				NbBalles_Barillet(BLEUE)<NbBalles &&					// ... ou si on a les 3 balles blanches
				!(IO_Sw_Gauche() && IO_Sw_Droit()));					// ... ou si on a les deux switchs

		Stop_Propulsion();												// On arrte les moteurs

		if (IO_Sw_Gauche() && IO_Sw_Droit())							// Si on a les deux switchs, on recale
			Force_Propulsion(X_Propulsion(),234, -1571);

		ToutDroit_Propulsion (60, -50);									// On recule de 5cm
		while (	Etat_Propulsion ()!='a') 								// Jusqu' ce que l'on soit arriv
		{
			if (Barillet_Avale() && NbBalles_Barillet(BLEUE)>=NbBalles-1)	// Si on choppe une balles et que c'est la dernire, on inverse les rouleaux
			{
				Commande_Rouleaux(-80, -80);							// Normalement, on a chopper une balle, on inverse les rouleaux pour ne pas en prendre une seconde
				while (	Etat_Propulsion ()!='a');						// Jusqu' ce que l'on soit arriv ...
			}
		}

		while (Barillet_Busy());										// Attends que la barillet ne soit plus occupp ...																		// ... ce qui permet de connatre la couleur de la balle
		i++;															// Incrmente le nombre d'aller/retour
	}

	if (NbBalles_Barillet(BLEUE)!=NbBalles)
	{
		ToutDroit_Propulsion (30, 50);										// Avance de 3 cm pour chopper la dernire balle
		while (IsMove_Propulsion());
		ToutDroit_Propulsion (60, -50);										// Recule pour se dgager du distributeur
		while (IsMove_Propulsion());
	}


	Nb_Balles_Distributeur_Bleu-=NbBalles_Barillet(BLEUE)-NbBalleDebut;	// Dcrmente le nombre de balles connu dans le distributeur
	if (Nb_Balles_Distributeur_Bleu<0)
		Nb_Balles_Distributeur_Bleu=0;
}






// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur bleu
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments :
 * 	Le nombre de balles bleues dsir dans le barillet
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 *
 * Paramtre retourn :
 *  aucun


void Distributeur_Bleu (char NbBalles, char NbEssaisSup)
{
	char NbBalleDebut=NbBalles_Barillet(BLEUE);							// On regarde le nombre de balles dans le barillet avant la manoeuvre
	char i=NbBalleDebut-NbEssaisSup;									// On initialise i avec le nombre de blanches dj prsentes dans le barillet - le nombre d'essais suplmentaires

	//print_str ("Distri bleu\n");

	if (NbBalles-NbBalleDebut>Nb_Balles_Distributeur_Bleu)				// S'il y a moins de balles dans le distributeur que ce que l'on souhaite prendre
		NbBalles=NbBalleDebut+Nb_Balles_Distributeur_Bleu;			// On prend le maximum


	while(	NbBalles_Barillet(BLEUE)<NbBalles &&			 			// Si on a pas le nombre de balles dsir ...
			NbBalles_Barillet(TOUTES)<5	&&								// ... et que le barillet n'est pas plein
			i<NbBalles)													// ... et qu'on a pas encore puise notre quota de tentatives
	{
		//print_str ("Avance\n");
		Commande_Rouleaux(120, 90);										// On fait tourner les rouleaux pour attraper les balles

		GotoXY_Propulsion(700, 0, 25);									// Avancer doucement vers le distributeur
		while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
				!Barillet_Avale() &&									// ... ou qu'on vient de pcho une balle
				NbBalles_Barillet(BLEUE)<NbBalles &&					// ... ou si on a les 3 balles blanches
				!(IO_Sw_Gauche() && IO_Sw_Droit()));					// ... ou si on a les deux switchs

//		Stop_Propulsion();												// On arrte les moteurs
		//print_strint("stop=", Stop_Propulsion(), 1);

		if (IO_Sw_Gauche() && IO_Sw_Droit())							// Si on a les deux switchs, on recale
			Force_Propulsion(X_Propulsion(),234, -1571);

		//print_str ("Recule\n");
		ToutDroit_Propulsion (60, -50);									// On recule de 5cm
		while (	Etat_Propulsion ()!='a' )								// Jusqu' ce que l'on soit arriv
		{
			if (Barillet_Avale() && NbBalles_Barillet(BLEUE)>=NbBalles-1)	// Si on choppe une balles, on inverse les rouleaux et que c'est la dernire
			{
				Commande_Rouleaux(-80, -80);							// Normalement, on a chopper une balle, on inverse les rouleaux pour ne pas en prendre une seconde
				while (	Etat_Propulsion ()!='a');						// Jusqu' ce que l'on soit arriv ...

			}
		}

		while (Barillet_Busy());										// Attends que la barillet ne soit plus occupp ...
																		// ... ce qui permet de connatre la couleur de la balle
		i++;															// Incrmente le nombre d'aller/retour
	}

	if (NbBalles_Barillet(BLEUE)!=NbBalles)
	{
		ToutDroit_Propulsion (30, 50);										// Avance de 3 cm pour chopper la dernire balle
		while (IsMove_Propulsion());
		ToutDroit_Propulsion (60, -50);										// Recule pour se dgager du distributeur
		while (IsMove_Propulsion());
	}

	Nb_Balles_Distributeur_Bleu-=NbBalles_Barillet(BLEUE)-NbBalleDebut;	// Dcrmente le nombre de balles connu dans le distributeur
	if (Nb_Balles_Distributeur_Bleu<0)
		Nb_Balles_Distributeur_Bleu=0;
}
*/





// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur blanc du ct bleu
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments :
 * 	Le nombre de balles blanches dsir dans le robot
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 *
 * Paramtre retourn :
 *  aucun
*/

void Distributeur_Blanc_Bleu (char NbBalles,char NbEssaisSup)
{
	char NbBalleDebut=NbBalles_Barillet(BLANCHE);						// On regarde le nombre de balles dans le barillet avant la manoeuvre
	char i=NbBalleDebut-NbEssaisSup;									// On initialise i avec le nombre de blanches dj prsentes dans le barillet - le nombre d'essais suplmentaires

	if (NbBalles-NbBalleDebut>Nb_Balles_Distributeur_Blanc_Bleu)		// S'il y a moins de balles dans le distributeur que ce que l'on souhaite prendre
		NbBalles=NbBalleDebut+Nb_Balles_Distributeur_Blanc_Bleu;		// On prend le maximum


	while(	NbBalles_Barillet(BLANCHE)<NbBalles	&&			 			// Si on a pas le nombre de balles dsir ...
			NbBalles_Barillet(TOUTES)<5	&&								// ... et que le barillet n'est pas plein
			i<NbBalles)													// ... et qu'on a pas encore puise notre quota de tentatives
	{
		Commande_Rouleaux(120, 90);										// On fait tourner les rouleaux pour attraper les balles

		GotoXY_Propulsion(3000, Y_DISTRI_BLANC, 25);					// Avancer doucement vers le distributeur
		while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
				! Barillet_Avale() &&									// ... ou qu'on vient de pcho une balle
				NbBalles_Barillet(BLANCHE)<NbBalles &&					// ... ou si on a les 3 balles blanches
				!(IO_Sw_Gauche() && IO_Sw_Droit()));					// ... ou si on a les deux switchs

		Stop_Propulsion();												// On arrte les moteurs

		if (IO_Sw_Gauche() && IO_Sw_Droit())							// Si on a les deux switchs, on recale
			Force_Propulsion(2766,Y_Propulsion(),0);

		ToutDroit_Propulsion (60, -50);									// On recule de 5cm
		while (	Etat_Propulsion()!='a')									// Jusqu' ce que l'on soit arriv ...
		{
			if (Barillet_Avale() && NbBalles_Barillet(BLANCHE)>=NbBalles-1)	// Si on choppe une balles, on inverse les rouleaux et que c'est la dernire
			{
				Commande_Rouleaux(-80, -80);							// Normalement, on a chopper une balle, on inverse les rouleaux pour ne pas en prendre une seconde
				while (	Etat_Propulsion()!='a');						// Jusqu' ce que l'on soit arriv ...

			}
		}
		while (Barillet_Busy());										// Attends que la barillet ne soit plus occupp ...
																		// ... ce qui permet de connatre la couleur de la balle
		i++;															// Incrmente le nombre d'aller/retour
	}
	if (NbBalles_Barillet(BLANCHE)!=NbBalles)
	{
		ToutDroit_Propulsion (30, 50);										// Avance de 3 cm pour chopper la dernire balle
		while (IsMove_Propulsion());
		ToutDroit_Propulsion (60, -50);										// Recule pour se dgager du distributeur
		while (IsMove_Propulsion());
	}
																		// Dcrmente le nombre de balles connu dans le distributeur
	Nb_Balles_Distributeur_Blanc_Bleu-=NbBalles_Barillet(BLANCHE)-NbBalleDebut;
	if (Nb_Balles_Distributeur_Blanc_Bleu<0)
		Nb_Balles_Distributeur_Blanc_Bleu=0;
}






// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur blanc du ct rouge
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments :
 * 	Le nombre de balles blanches dsir dans le robot
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 *
 * Paramtre retourn :
 *  aucun
*/

void Distributeur_Blanc_Rouge (char NbBalles, char NbEssaisSup)
{
	char NbBalleDebut=NbBalles_Barillet(BLANCHE);						// On regarde le nombre de balles dans le barillet avant la manoeuvre
	char i=NbBalleDebut-NbEssaisSup;									// On initialise i avec le nombre de blanches dj prsentes dans le barillet - le nombre d'essais suplmentaires

	if (NbBalles-NbBalleDebut>Nb_Balles_Distributeur_Blanc_Rouge)		// S'il y a moins de balles dans le distributeur que ce que l'on souhaite prendre
		NbBalles=NbBalleDebut+Nb_Balles_Distributeur_Blanc_Rouge;		// On prend le maximum

	while(	NbBalles_Barillet(BLANCHE)<NbBalles	&&			 			// Si on a pas le nombre de balles dsir ...
			NbBalles_Barillet(TOUTES)<5	&&								// ... et que le barillet n'est pas plein
			i<NbBalles)													// ... et qu'on a pas encore puise notre quota de tentatives
	{
		Commande_Rouleaux(120, 90);										// On fait tourner les rouleaux pour attraper les balles

		GotoXY_Propulsion(0, Y_DISTRI_BLANC, 25);						// Avancer doucement vers le distributeur
		while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
				! Barillet_Avale() &&									// ... ou qu'on vient de pcho une balle
				NbBalles_Barillet(BLANCHE)<NbBalles &&					// ... ou si on a les 3 balles blanches
				!(IO_Sw_Gauche() && IO_Sw_Droit()));					// ... ou si on a les deux switchs

		Stop_Propulsion();												// On arrte les moteurs

		if (IO_Sw_Gauche() && IO_Sw_Droit())							// Si on a les deux switchs, on recale
			Force_Propulsion(234,Y_Propulsion(),3141);


		ToutDroit_Propulsion (60, -50);									// On recule de 5cm
		while (	Etat_Propulsion()!='a')								// Jusqu' ce que l'on soit arriv ...
		{
			if (Barillet_Avale() && NbBalles_Barillet(BLANCHE)>=NbBalles-1)	// Si on choppe une balles, on inverse les rouleaux et que c'est la dernire
			{
				Commande_Rouleaux(-80, -80);							// Normalement, on a chopper une balle, on inverse les rouleaux pour ne pas en prendre une seconde
				while (	Etat_Propulsion()!='a');						// Jusqu' ce que l'on soit arriv ...

			}
		}
		while (Barillet_Busy());										// Attends que la barillet ne soit plus occupp ...
																		// ... ce qui permet de connatre la couleur de la balle
		i++;															// Incrmente le nombre d'aller/retour

	}
	if (NbBalles_Barillet(BLANCHE)!=NbBalles)
	{
		ToutDroit_Propulsion (30, 50);										// Avance de 3 cm pour chopper la dernire balle
		while (IsMove_Propulsion());
		ToutDroit_Propulsion (60, -50);										// Recule pour se dgager du distributeur
		while (IsMove_Propulsion());
	}
	Nb_Balles_Distributeur_Blanc_Rouge-=NbBalles_Barillet(BLANCHE)-NbBalleDebut;
	if (Nb_Balles_Distributeur_Blanc_Rouge<0)
		Nb_Balles_Distributeur_Blanc_Rouge=0;

}



// --------------------------------------------------------------------------
/* Routine fait le complment de balles
 * On supose que l'on est proche du point 2650,350
 * Arguments :
 * 	bleue : Nombre de balles bleues qu'on veut dans le barillet
 *  blanche : Nombre de balles blanches qu'on veut dans le barillet
 *  recal : 1 s'il faut se recaler, 0 sinon
 *
 * Paramtre retourn :
 *  -1 : plus de balles dans les distributeurs ou bien rien  prendre
 *  -2 : l'adversaire nous a gn
*/
char Complement_Bleu(char bleue,char blanche, char recal)
{
	char blanche_a_prendre = 0;
	char bleue_a_prendre = 0;
	char adv_present = 0;
    int i;

	blanche_a_prendre = blanche - NbBalles_Barillet(BLANCHE);	// nb de balles blanches  prendre
	bleue_a_prendre = bleue - NbBalles_Barillet(BLEUE);			// nb de balles bleues  prendre

	if(Nb_Balles_Distributeur_Blanc_Bleu==0)					// s'il n'y a plus de blanches dans le distri
		blanche_a_prendre=0;									// pas la peine d'y aller


	if(Nb_Balles_Distributeur_Bleu==0)							// s'il n'y a plus de bleues dans le distri
		bleue_a_prendre=0;										// pas la peine d'y aller

	if((bleue_a_prendre<=0)&&(blanche_a_prendre<=0))			// s'il n'y a rien  prendre
		return -1;												// quitter



	if( recal )
		Recal_Cote_Bleu(bleue_a_prendre>0,blanche_a_prendre>0);	// on se recale en X et/ou en Y

	if(blanche_a_prendre)										// s'il y a des blanches  prendre
	{

		if ((A_Propulsion()>-785 || A_Propulsion()<785)	&& recal)		// Si le robot n'a pas la bonne orientation pour reculer vers le distributeur blanc, on se place correctement
		{
			GotoXY_Propulsion (2650,350,-40);					// Recule au point de recalage
			while (	IsMove_Propulsion() );

			// Recallage en Y

			Angle_Propulsion (-PI/2.0,40);						// S'oriente face  la longueur de la table
			while (	IsMove_Propulsion() );
		}

		GotoXY_Propulsion(2550,750, -60);						// On va en face du distributeur
		do
		{																// Si on voit le robot adverse, on s'arrte
			adv_present = Adversaire_Derriere(); //>=2;
			//print_int (adv_present);
			adv_present=adv_present>=2;
			//print_str ("\n");
		}
		while ( IsMove_Propulsion() && !adv_present );

		Stop_Propulsion();
		while (Etat_Propulsion()!='a');

		if( !adv_present )										// Il n'y a pas d'adversaire
		{
			Angle_Propulsion(0,30);							// On s'oriente vers le distributeur blanc
			while (IsMove_Propulsion());
			
			if( !recal )
				OrienteMax_Telemetre(10);
			Distributeur_Blanc_Bleu(blanche,2);				// On prend le nombre de balles dsir
		}
		else
		{
			GotoXY_Propulsion(2600,400, 60);
			while ( IsMove_Propulsion() ) ;
			Angle_Propulsion(0,30);							// On s'oriente pour reculer vers le distributeur bleu
			while (IsMove_Propulsion());
		}

	}

	if(bleue_a_prendre)											// s'il y a des bleues  prendre
	{

		GotoXY_Propulsion(2300,500, -60);						// On va en face du distributeur bleu
		do
		{
			// si on voit le robot adverse, on s'arrte
			adv_present = Adversaire_Derriere()>=2;
		}
		while ( IsMove_Propulsion() && !adv_present );

		if( adv_present || Etat_Propulsion()=='g' ){
			Stop_Propulsion();
			return -2;
		}
		Stop_Propulsion();

		Angle_Propulsion(-PI/2.0,30);							// On s'oriente vers le distributeur bleu
		while (IsMove_Propulsion());

		if( Y_Propulsion()>400 ){
			GotoXY_Propulsion(2300,350, 60);	// On va en face du distributeur
			while ( IsMove_Propulsion() );
			Stop_Propulsion();
		}

        for (i=NbBalles_Barillet(BLANCHE);i>3;i--)
		{
			DeposeBalle_Barillet(BLANCHE);
			Delay10KTCYx(10);
		}
		while (Barillet_Busy());

//		if( !recal )
//			OrienteMax_Telemetre(10);
		Distributeur_Bleu(bleue,2);							// On prend le nombre de balles dsires

	}
	return 0;
}
