#include <delays.h>


#include "Goto_Conteneur.h"
#include "strategie_bleu.h"
#include "Recal.h"
#include "tourelle.h"
#include "mystdio.h"
#include "Constante.h"




// retourne 1 si on est cal au bord du conteneur
// retourne 0 si on a pas russi  se caler au bord du conteneur (trop d'vitements ou bug)

unsigned char Goto_Conteneur(int X)
{
	unsigned char	etat=0;										// Etat courant de la machine principale
	unsigned char   Etat_Rouleaux=0;							// Etat courant de la machine  tat pour les rouleaux
	
	char		ismoving=0;
	char		transition=1;
	char		NbEvit=0;
	long int	Xrobot;											// On lit la position du robot
	long int	Yrobot;
	long int	Distance_Cible;
	float 		Beta;
	int 		Psi;		
	
	
	while(etat<254)
	{
		// --------------------------------------------------------------
		// Mesures des capteurs
		
		if( transition )										// Affiche l'tat courante de la machine
			print_strint( ">GT Con=", etat, 1 );
		

		ismoving = IsMove_Propulsion();							// Mesure si un mouvement est en cours

		if( transition && etat!=0 && etat!=1)					// Ne pas arrter les moteurs entre les changements de vitesse
		{
			Stop_Propulsion();
			while (Etat_Propulsion()!='a');
		}
		
		// --------------------------------------------------------------
		// Machine  tat pour les rouleaux
		
		switch (Etat_Rouleaux){
			case 0 :  
				if (NbBalles_Barillet(TOUTES)==5) 				// Si on a 5 balles dans le robot
					Etat_Rouleaux=1;							// On change d'tat 
					break;
					
			case 1 : 
					Commande_Rouleaux(-60, -60);				// On inverse le sens des rouleaux
					Etat_Rouleaux=2;							// On quitte cet tat pour ne pas rexecuter la commande 
					break;
		}
		
		
		Delay100TCYx(1);										// Attente entre deux cycles
	
		// --------------------------------------------------------------
		// Machine  tat pour les rouleaux	
			
		switch (etat){
			
			case 0:	/*
				print_int(Telemetre_Arriere());
				print_str(" ");		*/
						
				if( transition ){
					GotoXY_Propulsion(X,Y_CONTENEUR,-80);
					if (X<1500)
						Servo_Gauche_Barillet();
					else
						Servo_Droite_Barillet();					
					transition=0;
				}
				else if(Angle_Robot_Adverse()<225 &&						// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
						Angle_Robot_Adverse()>32 &&
						Distance_Robot_Adverse()) {
					transition = 1;
					etat = 1;
				} 
				else if(Telemetre_Arriere()>=DISTANCE_OBSTACLE )	{				
					transition=1;
					etat=2;
				}				
			
				
				else if( Etat_Propulsion()=='g' )
				{
					print_str ("Blocage lent\n");
					transition = 1;
					etat = 2;	
				}
				else if( Etat_Propulsion()=='a' )
				{
					transition = 1;
					etat = 4;						
				}
				break;
			
			
			
			
			case 1:	
				if( transition ){
					GotoXY_Propulsion(X,Y_CONTENEUR,-100);
					transition=0;
				}else if(Angle_Robot_Adverse()>220 ||						// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
						Angle_Robot_Adverse()<35 ||
						!Distance_Robot_Adverse()){
					transition = 1;
					etat = 0;
				} 
				else if( Etat_Propulsion()=='g' )
				{
					Stop_Propulsion();
					print_str ("Blocage Rapide\n");
					transition = 1;
					etat = 2;	
				}
				else if( Etat_Propulsion()=='a' )
				{
					transition = 1;
					etat = 4;						
				}
				break;
			
			
			
			case 2:

				Xrobot=X_Propulsion();																// On lit la position du robot
				Yrobot=Y_Propulsion();
				
				Distance_Cible=(X-Xrobot)*(X-Xrobot)+(Y_CONTENEUR-Yrobot)*(Y_CONTENEUR-Yrobot);		// Calcule la distance entre le robot et la cible
			
				if(	NbBalles_Barillet(BLEUE)>0 && (Distance_Cible<1000000 || 						// Si on a au moins 1 balle bleue et (qu'on est proche de la cible ...
					NbEvit>=3) ){									// ... ou qu'on a fait 2 vitements sans voir l'adversaire) 
						transition=1;
						etat=40;																	// On passe en 40 (changement de cible)
				}
				else if(NbEvit<3 || NbBalles_Barillet(BLEUE)==0 ) {									// si on a fait - de 3 vitements ou qu'on n'a pas de balles bleues
					transition = 1;
					etat = 3;
				}
				else if( NbEvit>=5 ){																// si on a fait + de 5 vitements
					transition = 1;
					etat = 254;
				}
				else {
					transition = 1;
					etat = 50;
				}  
				break;
			
			
			case 3:	
				NbEvit++;
				Evite_Robot_Adverse(NbEvit);
				transition = 1;
				etat = 0;	
				break;
			

			case 4:	
				if( transition ){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 5;	
				}
				break;
			
						
			case 5:	
				if( transition ){
					transition=0;
				}else if(Adversaire_Derriere()>=2){
					transition=1;
					etat=7;
				}
				else if( !ismoving ){
					transition = 1;
					etat = 6;	
				}
				break;
			
			
			case 6:	
				Commande_Rouleaux(-60, -60); 							// Inverse le sens des rouleaux
				if(Recal_Arriere()){
					Force_Propulsion(X_Propulsion(),2035,-1571);
					transition=1;
					etat=255;
				}
				else{
					transition=1;
					etat=7;
				}
				break;
			
			case 7:	
				if(transition){
					ToutDroit_Propulsion(750,50);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=60;
				}
				break;
			
			
			case 40:
				Psi=A_Propulsion();	
				if( Psi>(-1000*PI/2.000) && Psi<(1000*PI/2.000) ){
					transition=1;
					etat = 70;
				}else {
					transition = 1;
					etat = 60;	
				}
				break;
			
			
			case 50:	
				
				Psi=A_Propulsion();
				Beta=Angle_Absolu_Robot_Adverse();
				
				if(		(Psi>(-1000*PI/2.000) && Psi<(1000*PI/2.000)) &&
						(Beta>(-PI/2.000) && Beta<(PI/2.000)) ){
					transition=1;
					etat=70;
				}
				else if(	!(Psi>-1000*PI/2.000 && Psi<1000*PI/2.000) &&
							 (Beta>-PI/2.000 && Beta<PI/2.000) ){
					transition=1;
					etat=60;
				} 
				else if(	 (Psi>-1000*PI/2.000 && Psi<1000*PI/2.000) &&
							!(Beta>-PI/2.000 && Beta<PI/2.000) ){
					transition=1;
					etat=80;
				} 
				else {				
					transition=1;
					etat=90;
				}
				break;
			
			
			case 60:	
				if( transition ){
					GotoXY_Propulsion(2500,Y_CONTENEUR,-100);
					Servo_Droite_Barillet();
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 100;	
				}
				break;
			
			case 70:	
				if( transition ){
					GotoXY_Propulsion(2500,Y_CONTENEUR,100);
					Servo_Droite_Barillet();
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 100;	
				}
				break;
			
			
			case 80:	
				if( transition ){
					GotoXY_Propulsion(500,Y_CONTENEUR,-100);
					Servo_Droite_Barillet();
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 100;	
				}
				break;
			
			
			case 90:	
				if( transition ){
					GotoXY_Propulsion(500,Y_CONTENEUR,+100);
					Servo_Droite_Barillet();
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 100;	
				}
				break;
			
			
			case 100:	
				if( transition ){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 101;	
				}
				break;
			
			
			case 101:	
				Commande_Rouleaux(-60, -60); 							// Inverse le sens des rouleaux
				if (Recal_Arriere())
				{
					Force_Propulsion(X_Propulsion(),2035,-1571);
					transition = 1;
					etat = 255;	
				}
				else
				{
					transition = 1;
					etat = 254;	
				}
				break;
			

			default :	// pas normal : quitter
				etat = 254;


			} // fin switch(etat)
			
	} // fin while(etat<254)
	
	Stop_Propulsion();
	if( etat==255 )											// si on a atteint l'tat 255, c'est bon
		return 1;
	else
		return 0;											// sinon il y a eu un problme
}