// Fichier Propulsion.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/



#include <timers.h>



#define 	VAL_TIMER0		15536			// 10ms entre deux interruptions



// --------------------------------------------------------------------------
/* Arrte le robot  la fin du match
 * Coupe les moteurs et les rouleaux
 * Arguments : aucun 
 * 
 * Paramtre renvoy : aucun
*/
void Fin_Match(void);



// --------------------------------------------------------------------------
/* Initialise et dmarre le chronomtre de 90 secondes
 * Arguments : aucun 
 * 
 * Paramtre renvoy : aucun
*/
void StartHorloge(void);




// --------------------------------------------------------------------------
/* Retourne le nombre de centime de secondes coule depuis le dbut du match
 * Arguments : aucun 
 * 
 * Paramtre renvoy : centime de secondes
*/
int Cent_depuis_debut (void);





// --------------------------------------------------------------------------
/* Retourne le nombre de secondes coul depuis le dbut du match
 * Arguments : aucun 
 * 
 * Paramtre renvoy : secondes
*/
int Sec_depuis_debut (void);




// --------------------------------------------------------------------------
/* Vecteur d'interruption
*/
void InterruptVectorHigh(void); 





// --------------------------------------------------------------------------
/* Routine d'interruptions
 *  Met  jour le compteur
 *  Si la fin du match est atteinte, on appelle la fonction Fin_Match
 *  pour  stopper le robot
*/
void ServiceInterruptHigh(void);
