

// Fichier Depart_Bleue.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *			Recharge le barillet cot Bleue				*
 *                                                      *
 * .Date de cration : 23/04/08                         *
 * .Auteur : Jrmie LUMINEAU							*       
 *                                                      *
 * .Descriptions :                                      *
 *      - code du rechargement du barillet							*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"


#include "strategie_bleu.h"
#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "Horloge.h"
#include "led.h"
#include "Telemetres.h"
#include "serial.h"
#include "canon.h"
#include "Tourelle.h"
#include "Recal.h"
#include "Distributeur.h"
#include "tir.h"


// --------------------------------------------------------------------------
/* 
 * Se positionne pour tirer
 * Tir toutes les balles bleue du barillet
*/
void Tir (void)
{
	unsigned char consigne=160;
	
	Commande_Canon(consigne);																	// Activation du canon
	
	GotoXY_Propulsion(2300,500,-100);														// 
	while (	Etat_Propulsion ()!='a' );
	
	Angle_Propulsion (-0.46,25);															// S'oriente vers le conteneur rfrigr
	while (Etat_Propulsion ()!='a');
	
	Angle_Propulsion (-0.46,10);															// S'oriente vers le conteneur rfrigr
	while (Etat_Propulsion ()!='a');

	
/*	while (NbBalles_Barillet (BLEUE))														// Tant qu'il y a des balles dans le barillet
	{
		while ((Mesure_Moyenne_Canon(100)<158 || Mesure_Moyenne_Canon(100)>162) &&			// Vrification de la vitesse du canon 
				Sec_depuis_debut()<87);		
		TirBalle_Barillet( BLEUE );															// Tir une balle
		Delay10KTCYx(100);
		while (Barillet_Busy());
	}*/
	
	while (NbBalles_Barillet (BLEUE))													// Tant qu'il y a des balles dans le barillet
	{
		while ((Mesure_Moyenne_Canon(100)!=consigne) &&		// Vrification de la vitesse du canon
				Sec_depuis_debut()<88);			
		TirBalle_Barillet( BLEUE );														// Tir une balle
		while (Barillet_Busy());
	}

	
	Commande_Canon(0);																	// Arret du canon
}



// --------------------------------------------------------------------------
/* 
 * On revien cot bleu
 * on prend des balles bleu

void Retour_Cote_Rouge (void)
{
	Goto_Cote_Rouge();
	
	if (!(Distance_Robot_Adverse()!=0 &&										// Que l'on voit le robot adverse
		Angle_Absolu_Robot_Adverse()<PI-0.001 &&										// Est qu'il n'est pas dans le coin
	 	Angle_Absolu_Robot_Adverse()>-PI/2.0))						
	{
		GotoXY_Propulsion (350,350,60);										// Avance au point de recalage
		while (	Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');	
														
		Recal_Cote_Rouge (1,0);													// Recale le robot X et en Psi
		
	}
	
	Angle_Propulsion (-PI/2.0,30);												// S'oriente en face du distributeur
	while (Etat_Propulsion ()!='a');
	
	GotoXY_Propulsion(700, 0, 50);												// Avancer vers le distributeur en avant
	while (	Etat_Propulsion ()!='g' &&											// On arrte si on est bloqu ...
			Etat_Propulsion ()!='a' && 											// ... ou si on est arriv (l il y a un problme !)...
			Y_Propulsion ()>440 &&												// ... ou on est proche du distributeur
			NbBalles_Barillet(ROUGE)<2);										// ... ou si on a les 3 balles blanches
				
	Stop_Propulsion();															// On arrte les moteurs
	Distributeur_Rouge(2,1);														// Prends trois balles dans le distributeur
}

*/
//---------------------------------------------------------------------------
/*
 * Tir toutes les balles du barillet 
 * Les balles bleues en tirs longs
 * Les balles blanches en petits tirs
*/
void TirToutes(void)
{
	unsigned char consigne;
	int mesure,i;
	
	if (NbBalles_Barillet (BLEUE))															// Activation du canon 
		consigne = SPEED_TIR_CONTENEUR;																// Si on a des rouges, on tourne  155
	else if (NbBalles_Barillet (BLANCHE))
		consigne = SPEED_PETIT_TIR;																	// Si on a des blanches, on tourne  90
	else 
		return;

	Commande_Canon( consigne );
	
	GotoXY_Propulsion(2300,500,-80);														// On se place au point de tir
	while (	Etat_Propulsion ()!='a' );
	
	if (NbBalles_Barillet (BLEUE))
	{
		print_str("bleues...\n");
		// Tir des balles bleues
		Angle_Propulsion (-0.51,30);															// S'oriente vers le conteneur rfrigr
		while (Etat_Propulsion ()!='a');
		
		Angle_Propulsion (-0.51,10);															// S'oriente vers le conteneur rfrigr
		while (Etat_Propulsion ()!='a');
	
		do
		{
			mesure=Mesure_Moyenne_Canon(100);
			print_strint(",v=",mesure,0);
		}
		while (mesure < consigne-1 );
	
		for (i=NbBalles_Barillet (BLEUE);i>0;i--)
		{
			TirBalle_Barillet( BLEUE );															// Tir une balle
			Delay10KTCYx(200);
		}
	
												
		Delay10KTCYx(200);
		while (Barillet_Busy());	
	}
	print_str("ok\n");
	
	
	if (NbBalles_Barillet (BLANCHE))															// Si on a des blanches
	{
		print_str("blanches...\n");
		// Tir des balles blanches
		consigne = SPEED_PETIT_TIR;
		Commande_Canon(consigne);																		// On baisse la vitesse du canon
		
		Angle_Propulsion (-0.54,30);															// S'oriente vers le conteneur rfrigr
		while (Etat_Propulsion ()!='a');
		
		Angle_Propulsion (-0.54,10);															// S'oriente vers le conteneur rfrigr
		while (Etat_Propulsion ()!='a');
	
	
		while (NbBalles_Barillet (BLANCHE))														// Tant qu'il y a des balles dans le barillet
		{
			Delay10KTCYx(255);
/*
			Delay10KTCYx(255);
			
			do
			{
				mesure=Mesure_Moyenne_Canon(100);
				print_strint(",v=",mesure,0);
			}
			while ((mesure < consigne-1 || 
					mesure > consigne+1) &&			// Vrification de la vitesse du canon
					Sec_depuis_debut()<87);
*/					
					
					
			TirBalle_Barillet( BLANCHE );															// Tir une balle
			Delay10KTCYx(200);
			while (Barillet_Busy());
		}
	}
	print_str("ok");
	Commande_Canon(0);	
}

